/*
 * Websock: high-performance binary WebSockets
 * Copyright (C) 2011 Joel Martin
 * Licensed under LGPL-3 (see LICENSE.txt)
 *
 * Websock is similar to the standard WebSocket object but Websock
 * enables communication with raw TCP sockets (i.e. the binary stream)
 * via websockify. This is accomplished by base64 encoding the data
 * stream between Websock and websockify.
 *
 * Websock has built-in receive queue buffering; the message event
 * does not contain actual data but is simply a notification that
 * there is new data available. Several rQ* methods are available to
 * read binary data off of the receive queue.
 */
function Websock(){"use strict";function e(){return N}function t(){return x}function n(){return k}function l(e){k=e}function a(){return x.length-k}function o(){return x[k]}function r(){return x[k++]}function s(e){0===k?x.unshift(e):(k-=1,x[k]=e)}function i(){return(x[k++]<<8)+x[k++]}function u(){return(x[k++]<<24)+(x[k++]<<16)+(x[k++]<<8)+x[k++]}function d(e){"undefined"==typeof e&&(e=a());var t=x.slice(k,k+e);return k+=e,t.map(function(e){return String.fromCharCode(e)}).join("")}function c(e){return"undefined"==typeof e&&(e=a()),k+=e,x.slice(k-e,k)}function p(e,t){return t?x.slice(k+e,k+t):x.slice(k+e)}function m(e,t,n){var l=x.length-k;if(t>l){if(n){if(n>k)throw"rQwait cannot backup "+n+" bytes";k-=n}return!0}return!1}function h(){return Base64.encode(N)}function f(e){x=x.concat(Base64.decode(e,0))}function g(){return 0!==E.bufferedAmount&&Util.Debug("bufferedAmount: "+E.bufferedAmount),E.bufferedAmount<_.maxBufferedAmount?(N.length>0&&(E.send(h(N)),N=[]),!0):(Util.Info("Delaying send, bufferedAmount: "+E.bufferedAmount),!1)}function v(e){return N=N.concat(e),g()}function b(e){_.send(e.split("").map(function(e){return e.charCodeAt(0)}))}function y(e){try{f(e.data),a()>0?(I.message(),x.length>F&&(x=x.slice(k),k=0)):Util.Debug("Ignoring empty message")}catch(t){Util.Warn("undefined"!=typeof t.stack?"recv_message, caught exception: "+t.stack:"undefined"!=typeof t.description?"recv_message, caught exception: "+t.description:"recv_message, caught exception:"+t),I.error("undefined"!=typeof t.name?t.name+": "+t.message:t)}}function w(e,t){I[e]=t}function A(){x=[],k=0,N=[],E=null}function C(e){A(),E=T?{}:new WebSocket(e,"base64"),E.onmessage=y,E.onopen=function(){Util.Debug(">> WebSock.onopen"),E.protocol&&Util.Info("Server chose sub-protocol: "+E.protocol),I.open(),Util.Debug("<< WebSock.onopen")},E.onclose=function(e){Util.Debug(">> WebSock.onclose"),I.close(e),Util.Debug("<< WebSock.onclose")},E.onerror=function(e){Util.Debug(">> WebSock.onerror: "+e),I.error(e),Util.Debug("<< WebSock.onerror")}}function S(){E&&((E.readyState===WebSocket.OPEN||E.readyState===WebSocket.CONNECTING)&&(Util.Info("Closing WebSocket connection"),E.close()),E.onmessage=function(){})}function P(e){return T=!0,_.send=e,_.close=function(){},y}function D(){return _.maxBufferedAmount=200,_.get_sQ=e,_.get_rQ=t,_.get_rQi=n,_.set_rQi=l,_.rQlen=a,_.rQpeek8=o,_.rQshift8=r,_.rQunshift8=s,_.rQshift16=i,_.rQshift32=u,_.rQshiftStr=d,_.rQshiftBytes=c,_.rQslice=p,_.rQwait=m,_.flush=g,_.send=v,_.send_string=b,_.on=w,_.init=A,_.open=C,_.close=S,_.testMode=P,_}var _={},E=null,x=[],k=0,F=1e4,N=[],I={message:function(){},open:function(){},close:function(){},error:function(){}},T=!1;return D()}window.WebSocket&&!window.WEB_SOCKET_FORCE_FLASH?Websock_native=!0:window.MozWebSocket&&!window.WEB_SOCKET_FORCE_FLASH?(Websock_native=!0,window.WebSocket=window.MozWebSocket):(Websock_native=!1,function(){function e(){return"undefined"!=typeof INCLUDE_URI?INCLUDE_URI:"include/"}var t="<script src='"+e(),n="'></script>",l="";window.WEB_SOCKET_SWF_LOCATION=e()+"web-socket-js/WebSocketMain.swf",Util.Engine.trident&&(Util.Debug("Forcing uncached load of WebSocketMain.swf"),window.WEB_SOCKET_SWF_LOCATION+="?"+Math.random()),l+=t+"web-socket-js/swfobject.js"+n,l+=t+"web-socket-js/web_socket.js"+n,document.write(l)}());