/*
 * noVNC: HTML5 VNC client
 * Copyright (C) 2011 Joel Martin
 * Licensed under LGPL-3 (see LICENSE.txt)
 *
 * See README.md for usage and integration instructions.
 */
function Display(e){"use strict";function t(){Util.Debug(">> Display.constructor");var e,t,n,l,a=Util.Engine;if(!i.target)throw"target must be set";if("string"==typeof i.target)throw"target must be a DOM element";if(e=i.target,!e.getContext)throw"no getContext method";if(u||(u=e.getContext("2d")),Util.Debug("User Agent: "+navigator.userAgent),a.gecko&&Util.Debug("Browser: gecko "+a.gecko),a.webkit&&Util.Debug("Browser: webkit "+a.webkit),a.trident&&Util.Debug("Browser: trident "+a.trident),a.presto&&Util.Debug("Browser: presto "+a.presto),s.clear(),!("createImageData"in u))throw"Canvas does not support createImageData";for(i.render_mode="canvas rendering",null===i.prefer_js&&(Util.Info("Prefering javascript operations"),i.prefer_js=!0),g=u.createImageData(16,16),n=[],t=0;256>t;t+=1)n.push(255);try{l=e.style.cursor,changeCursor(i.target,n,n,2,2,8,8),e.style.cursor?(null===i.cursor_uri&&(i.cursor_uri=!0),Util.Info("Data URI scheme cursor supported")):(null===i.cursor_uri&&(i.cursor_uri=!1),Util.Warn("Data URI scheme cursor not supported")),e.style.cursor=l}catch(o){Util.Error("Data URI scheme cursor test exception: "+o),i.cursor_uri=!1}return Util.Debug("<< Display.constructor"),s}var n,l,a,o,r,s={},i={},u=null,d=0,c=0,p={x:0,y:0,w:0,h:0},m={x1:0,y1:0,x2:-1,y2:-1},h="",f=null,g=null,v=0,b=0;return Util.conf_defaults(i,s,e,[["target","wo","dom",null,"Canvas element for rendering"],["context","ro","raw",null,"Canvas 2D context for rendering (read-only)"],["logo","rw","raw",null,'Logo to display when cleared: {"width": width, "height": height, "data": data}'],["true_color","rw","bool",!0,"Use true-color pixel data"],["colourMap","rw","arr",[],"Colour map array (when not true-color)"],["scale","rw","float",1,"Display area scale factor 0.0 - 1.0"],["viewport","rw","bool",!1,"Use a viewport set with viewportChange()"],["width","rw","int",null,"Display area width"],["height","rw","int",null,"Display area height"],["render_mode","ro","str","","Canvas rendering mode (read-only)"],["prefer_js","rw","str",null,"Prefer Javascript over canvas methods"],["cursor_uri","rw","raw",null,"Can we render cursor using data URI"]]),s.get_context=function(){return u},s.set_scale=function(e){r(e)},s.set_width=function(e){s.resize(e,c)},s.get_width=function(){return d},s.set_height=function(e){s.resize(d,e)},s.get_height=function(){return c},r=function(e){var t,n,l,a,o=["transform","WebkitTransform","MozTransform",null];for(t=i.target,n=o.shift();n&&"undefined"==typeof t.style[n];)n=o.shift();return null===n?void Util.Debug("No scaling support"):("undefined"==typeof e?e=i.scale:e>1?e=1:.1>e&&(e=.1),void(i.scale!==e&&(i.scale=e,l=t.width-t.width*e,a=t.height-t.height*e,t.style[n]="scale("+i.scale+") translate(-"+l+"px, -"+a+"px)")))},o=function(e){var t,n;t=i.true_color?e:i.colourMap[e[0]],n="rgb("+t[2]+","+t[1]+","+t[0]+")",n!==h&&(u.fillStyle=n,h=n)},s.viewportChange=function(e,t,n,l){var a,o,r,s,h,f,g,v=i.target,b=p,y=m,w=null;i.viewport||(Util.Debug("Setting viewport to full display region"),e=-b.w,t=-b.h,n=d,l=c),"undefined"==typeof e&&(e=0),"undefined"==typeof t&&(t=0),"undefined"==typeof n&&(n=b.w),"undefined"==typeof l&&(l=b.h),n>d&&(n=d),l>c&&(l=c),(b.w!==n||b.h!==l)&&(n<b.w&&y.x2>b.x+n-1&&(y.x2=b.x+n-1),b.w=n,l<b.h&&y.y2>b.y+l-1&&(y.y2=b.y+l-1),b.h=l,b.w>0&&b.h>0&&v.width>0&&v.height>0&&(w=u.getImageData(0,0,v.width<b.w?v.width:b.w,v.height<b.h?v.height:b.h)),v.width=b.w,v.height=b.h,w&&u.putImageData(w,0,0)),s=b.x+b.w-1,h=b.y+b.h-1,0>e&&b.x+e<0&&(e=-b.x),s+e>=d&&(e-=s+e-d+1),b.y+t<0&&(t=-b.y),h+t>=c&&(t-=h+t-c+1),(0!==e||0!==t)&&(Util.Debug("viewportChange deltaX: "+e+", deltaY: "+t),b.x+=e,s+=e,b.y+=t,h+=t,b.x>y.x1&&(y.x1=b.x),s<y.x2&&(y.x2=s),b.y>y.y1&&(y.y1=b.y),h<y.y2&&(y.y2=h),0>e?(o=0,f=-e):(o=b.w-e,f=e),0>t?(r=0,g=-t):(r=b.h-t,g=t),a=u.fillStyle,u.fillStyle="rgb(255,255,255)",0!==e&&(u.drawImage(v,0,0,b.w,b.h,-e,0,b.w,b.h),u.fillRect(o,0,f,b.h)),0!==t&&(u.drawImage(v,0,0,b.w,b.h,0,-t,b.w,b.h),u.fillRect(0,r,b.w,g)),u.fillStyle=a)},s.getCleanDirtyReset=function(){var e,t=p,n=m,l=[],a=t.x+t.w-1,o=t.y+t.h-1;return e={x:n.x1,y:n.y1,w:n.x2-n.x1+1,h:n.y2-n.y1+1},n.x1>=n.x2||n.y1>=n.y2?l.push({x:t.x,y:t.y,w:t.w,h:t.h}):(t.x<n.x1&&l.push({x:t.x,y:t.y,w:n.x1-t.x+1,h:t.h}),a>n.x2&&l.push({x:n.x2+1,y:t.y,w:a-n.x2,h:t.h}),t.y<n.y1&&l.push({x:n.x1,y:t.y,w:n.x2-n.x1+1,h:n.y1-t.y}),o>n.y2&&l.push({x:n.x1,y:n.y2+1,w:n.x2-n.x1+1,h:o-n.y2})),m={x1:t.x,y1:t.y,x2:t.x+t.w-1,y2:t.y+t.h-1},{cleanBox:e,dirtyBoxes:l}},s.absX=function(e){return e+p.x},s.absY=function(e){return e+p.y},s.resize=function(e,t){h="",d=e,c=t,r(i.scale),s.viewportChange()},s.clear=function(){i.logo?(s.resize(i.logo.width,i.logo.height),s.blitStringImage(i.logo.data,0,0)):(s.resize(640,20),u.clearRect(0,0,p.w,p.h))},s.fillRect=function(e,t,n,l,a){o(a),u.fillRect(e-p.x,t-p.y,n,l)},s.copyImage=function(e,t,n,l,a,o){var r=e-p.x,s=t-p.y,d=n-p.x,c=l-p.y;u.drawImage(i.target,r,s,a,o,d,c,a,o)},s.startTile=function(e,t,n,l,a){var o,r,d,c,p,m;if(v=e,b=t,f=16===n&&16===l?g:u.createImageData(n,l),o=f.data,i.prefer_js)for(r=i.true_color?a:i.colourMap[a[0]],d=r[2],c=r[1],p=r[0],m=0;n*l*4>m;m+=4)o[m]=d,o[m+1]=c,o[m+2]=p,o[m+3]=255;else s.fillRect(e,t,n,l,a)},s.subTile=function(e,t,n,l,a){var o,r,u,d,c,p,m,h,g,y,w;if(i.prefer_js)for(o=f.data,m=f.width,u=i.true_color?a:i.colourMap[a[0]],d=u[2],c=u[1],p=u[0],y=e+n,w=t+l,h=t;w>h;h+=1)for(g=e;y>g;g+=1)r=4*(g+h*m),o[r]=d,o[r+1]=c,o[r+2]=p,o[r+3]=255;else s.fillRect(v+e,b+t,n,l,a)},s.finishTile=function(){i.prefer_js&&u.putImageData(f,v-p.x,b-p.y)},n=function(e,t,n,l,a,o){var r,s,i,d,c=p;for(r=u.createImageData(n,l),d=r.data,s=0,i=o;n*l*4>s;s+=4,i+=3)d[s]=a[i],d[s+1]=a[i+1],d[s+2]=a[i+2],d[s+3]=255;u.putImageData(r,e-c.x,t-c.y)},l=function(e,t,n,l,a,o){var r,s,i,d,c=p;for(r=u.createImageData(n,l),d=r.data,s=0,i=o;n*l*4>s;s+=4,i+=4)d[s]=a[i+2],d[s+1]=a[i+1],d[s+2]=a[i],d[s+3]=255;u.putImageData(r,e-c.x,t-c.y)},a=function(e,t,n,l,a,o){var r,s,d,c,m,h;for(r=u.createImageData(n,l),c=r.data,h=i.colourMap,s=0,d=o;n*l*4>s;s+=4,d+=1)m=h[a[d]],c[s]=m[2],c[s+1]=m[1],c[s+2]=m[0],c[s+3]=255;u.putImageData(r,e-p.x,t-p.y)},s.blitImage=function(e,t,n,o,r,s){i.true_color?l(e,t,n,o,r,s):a(e,t,n,o,r,s)},s.blitRgbImage=function(e,t,l,o,r,s){i.true_color?n(e,t,l,o,r,s):a(e,t,l,o,r,s)},s.blitStringImage=function(e,t,n){var l=new Image;l.onload=function(){u.drawImage(l,t-p.x,n-p.y)},l.src=e},s.changeCursor=function(e,t,n,l,a,o){return i.cursor_uri===!1?void Util.Warn("changeCursor called but no cursor data URI support"):void(i.true_color?changeCursor(i.target,e,t,n,l,a,o):changeCursor(i.target,e,t,n,l,a,o,i.colourMap))},s.defaultCursor=function(){i.target.style.cursor="default"},t()}function changeCursor(e,t,n,l,a,o,r,s){"use strict";var i,u,d,c,p,m,h,f,g,v,b=[];for(b.push16le=function(e){this.push(255&e,e>>8&255)},b.push32le=function(e){this.push(255&e,e>>8&255,e>>16&255,e>>24&255)},u=40,d=o*r*4,p=Math.ceil(o*r/8),c=Math.ceil(o*r/8),b.push16le(0),b.push16le(2),b.push16le(1),b.push(o),b.push(r),b.push(0),b.push(0),b.push16le(l),b.push16le(a),b.push32le(u+d+p+c),b.push32le(22),b.push32le(u),b.push32le(o),b.push32le(2*r),b.push16le(1),b.push16le(32),b.push32le(0),b.push32le(p+c),b.push32le(0),b.push32le(0),b.push32le(0),b.push32le(0),v=r-1;v>=0;v-=1)for(g=0;o>g;g+=1)h=v*Math.ceil(o/8)+Math.floor(g/8),f=n[h]<<g%8&128?255:0,s?(h=o*v+g,i=s[t[h]],b.push(i[2]),b.push(i[1]),b.push(i[0]),b.push(f)):(h=4*(o*v+g),b.push(t[h+2]),b.push(t[h+1]),b.push(t[h]),b.push(f));for(v=0;r>v;v+=1)for(g=0;g<Math.ceil(o/8);g+=1)b.push(0);for(v=0;r>v;v+=1)for(g=0;g<Math.ceil(o/8);g+=1)b.push(0);m="data:image/x-icon;base64,"+Base64.encode(b),e.style.cursor="url("+m+") "+l+" "+a+", default"}